import {Document} from '@react-pdf/renderer';
import Person from "../../data/Person.ts";
import AuszahlungPage from "./AuszahlungPage.tsx";
import Posten from "../../data/Posten.ts";
import Verzeichnis from "./Verzeichnis.tsx";
import Bank from "../../data/Bank.ts";


const styles = {
    document: {
        fontFamily: 'Helvetica',
    },
}

const MyDocument = ({person, bankdaten, posten}: { person: Person, bankdaten: Bank, posten: Posten[] }) => {
    return (
        <Document style={styles.document}>
            <AuszahlungPage person={person} bank={bankdaten} posten={posten}/>
            <Verzeichnis posten={posten}/>
        </Document>
    );
}

export default MyDocument;
