import Posten from "../../data/Posten.ts";
import {StyleSheet, Page, View, Text} from "@react-pdf/renderer";

const styles = StyleSheet.create({
    page: {
        flexDirection: 'column',
        backgroundColor: '#ffffff',
        paddingLeft: '2cm',
        paddingRight: '2cm',
        paddingTop: '1.5cm',
        paddingBottom: '1.5cm',
        fontFamily: 'Helvetica',
        fontSize: 11,
    },
    section: {},
    h1: {
        fontSize: 24,
        marginBottom: 10,
    },
    postenGroup: {
        marginBottom: 10,
    },
    posten: {},
    entryWithCheckbox: {
        display: 'flex',
        flexDirection: 'row',
        marginBottom: 8,
    },
    checkbox: {
        width: 12,
        height: 12,
        borderStyle: 'solid',
        borderWidth: 1,
        marginLeft: 5,
        marginRight: 5,
    }
});

const Verzeichnis = ({posten}: { posten: Posten[] }) => {
    let index = 1;
    const verzeichnisList = posten.map((posten) => {
        if (posten.getZahlungsart() === "Bar") {
            return (
                <View style={styles.postenGroup}>
                    <View style={styles.entryWithCheckbox}>
                        <Text style={styles.posten}>{index++}. Originalrechnung für Posten
                            Nr. {posten.getNummer()}</Text>
                        <View style={styles.checkbox}></View>
                    </View>
                </View>
            )
        } else if (posten.getZahlungsart() === "PayPal") {
            return (
                <View style={styles.postenGroup}>
                    <View style={styles.entryWithCheckbox}>
                        <Text style={styles.posten}>{index++}. Originalrechnung für Posten
                            Nr. {posten.getNummer()}</Text>
                        <View style={styles.checkbox}></View>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <Text style={styles.posten}>{index++}. PayPal Beleg für Posten Nr. {posten.getNummer()}</Text>
                        <View style={styles.checkbox}></View>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <Text style={styles.posten}>{index++}. Bankauszug für Posten Nr. {posten.getNummer()}</Text>
                        <View style={styles.checkbox}></View>
                    </View>
                </View>
            )
        } else {
            return (
                <View style={styles.postenGroup}>
                    <View style={styles.entryWithCheckbox}>
                        <Text style={styles.posten}>{index++}. Originalrechnung für Posten
                            Nr. {posten.getNummer()}</Text>
                        <View style={styles.checkbox}></View>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <Text style={styles.posten}>{index++}. Bankauszug für Posten Nr. {posten.getNummer()}</Text>
                        <View style={styles.checkbox}></View>
                    </View>
                </View>
            )
        }
    });

    return (
        <Page size="A4" wrap={true} style={styles.page}>
            <View style={styles.section}>
                <Text style={styles.h1}>Inhaltsverzeichnis der Anhänge</Text>
                <View style={styles.section}>
                    {verzeichnisList}
                </View>
            </View>
            <View style={styles.section}>
                <Text style={styles.h1}>Allgemeine Checkliste</Text>
                <View style={styles.section}>
                    <View style={styles.entryWithCheckbox}>
                        <View style={styles.checkbox}></View>
                        <Text>Kassenbons sind getackert, nicht geklebt</Text>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <View style={styles.checkbox}></View>
                        <Text>Bons, die länger als das Blatt sind, sind so gefaltet, dass sowohl Gesamtsumme als auch
                            Posten sichtbar sind</Text>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <View style={styles.checkbox}></View>
                        <Text>Anhänge sind mit Posten Nr. nummeriert</Text>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <View style={styles.checkbox}></View>
                        <Text>Rechnungen haben alle Rechnungssteller/in als Rechnungsadresse (nicht FaSTTUBe oder
                            TU)</Text>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <View style={styles.checkbox}></View>
                        <Text>Alle Rechnungen haben eine Rechnungsnummer</Text>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <View style={styles.checkbox}></View>
                        <Text>Alle Rechnungen haben eine Steuer ausgewiesen</Text>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <View style={styles.checkbox}></View>
                        <Text>Alle Rechnungen sind echte Rechnungen (keine Proforma, keine Angebote, keine
                            Lieferscheine)</Text>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <View style={styles.checkbox}></View>
                        <Text>Rechnungen in Auslandswährung haben entweder Umrechnungsfaktor auf dem Zahlungsbeleg oder
                            Nebenrechnung mit Umrechnungsfaktor des Rechnungsdatums ist angehängt</Text>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <View style={styles.checkbox}></View>
                        <Text>Privateinkäufe sind per Nebenrechnung herausgerechnet</Text>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <View style={styles.checkbox}></View>
                        <Text>Alles ist ausgedruckt und Deckblatt NUR oben links handschriftlich unterschrieben</Text>
                    </View>
                    <View style={styles.entryWithCheckbox}>
                        <View style={styles.checkbox}></View>
                        <Text>Alle Blätter sind mit Büroklammer zusammengeheftet und bei der Finanzleitung
                            abgegeben</Text>
                    </View>
                </View>
            </View>
        </Page>
    );
}

export default Verzeichnis;